diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index 6f64a7b56..33b7a21cd 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -510,21 +496,21 @@ public class ScreenOptions
 
         super.mouseReleased(mx, my, buttonNum);
 
-        int left = pagesListWidth + SEPARATOR_WIDTH + PADDING;
-        if (my >= top && my <= bottom) {
-            if (clickedComponent != null) {
+        int left = this.pagesListWidth + SEPARATOR_WIDTH + PADDING;
+        if (my >= this.top && my <= this.bottom) {
+            if (this.clickedComponent != null) {
                 if (buttonNum >= 0) {
-                    clickedComponent.onMouseRelease(buttonNum, left, clickedComponentY, pageWidth, mx - left, my - clickedComponentY);
-                    clickedComponent = null;
+                    this.clickedComponent.onMouseRelease(buttonNum, left, this.clickedComponentY, this.pageWidth, mx - left, my - this.clickedComponentY);
+                    this.clickedComponent = null;
                 } else {
-                    clickedComponent.onMouseMove(left, clickedComponentY, pageWidth, mx - left, my - clickedComponentY);
+                    this.clickedComponent.onMouseMove(left, this.clickedComponentY, this.pageWidth, mx - left, my - this.clickedComponentY);
                 }
             }
         }
 
-        if(buttonNum >= 0) {
-            clickX = null;
-            clickY = null;
+        if (buttonNum >= 0) {
+            this.clickX = null;
+            this.clickY = null;
         }
     }
 
@@ -532,48 +518,43 @@ public class ScreenOptions
     public void renderBackground() {
         super.renderBackground();
 
-        if (mc.currentWorld == null)
-        {
-            Tessellator tessellator = Tessellator.instance;
-            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        if (this.mc.currentWorld == null) {
+            TessellatorGeneral tessellator = GLRenderer.getTessellator();
+            this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            GLRenderer.setColor4f(1f, 1f, 1f, 1f);
             float scale = 32F;
             tessellator.startDrawingQuads();
-            tessellator.setColorOpaque_I(0x202020);
+            tessellator.setColorOpaque1i(0x202020);
 
-            tessellator.addVertexWithUV(0, bottom, 0.0D, 0, (float)(bottom + (int) optionsScrollAmount) / scale);
-            tessellator.addVertexWithUV(width, bottom, 0.0D, (float)width / scale, (float)(bottom + (int) optionsScrollAmount) / scale);
-            tessellator.addVertexWithUV(width, top, 0.0D, (float)width / scale, (float)(top + (int) optionsScrollAmount) / scale);
-            tessellator.addVertexWithUV(0, top, 0.0D, 0, (float)(top + (int) optionsScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0, (float) (this.bottom + (int) this.optionsScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.width, this.bottom, 0.0D, (float) this.width / scale, (float) (this.bottom + (int) this.optionsScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.width, this.top, 0.0D, (float) this.width / scale, (float) (this.top + (int) this.optionsScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.top, 0.0D, 0, (float) (this.top + (int) this.optionsScrollAmount) / scale);
 
-            tessellator.addVertexWithUV(0, bottom, 0.0D, 0, (float)(bottom + (int) pagesListScrollAmount) / scale);
-            tessellator.addVertexWithUV(pagesListWidth, bottom, 0.0D, (float) pagesListWidth / scale, (float)(bottom + (int) pagesListScrollAmount) / scale);
-            tessellator.addVertexWithUV(pagesListWidth, top, 0.0D, (float) pagesListWidth / scale, (float)(top + (int) pagesListScrollAmount) / scale);
-            tessellator.addVertexWithUV(0, top, 0.0D, 0, (float)(top + (int) pagesListScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0, (float) (this.bottom + (int) this.pagesListScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.pagesListWidth, this.bottom, 0.0D, (float) this.pagesListWidth / scale, (float) (this.bottom + (int) this.pagesListScrollAmount) / scale);
+            tessellator.addVertexWithUV(this.pagesListWidth, this.top, 0.0D, (float) this.pagesListWidth / scale, (float) (this.top + (int) this.pagesListScrollAmount) / scale);
+            tessellator.addVertexWithUV(0, this.top, 0.0D, 0, (float) (this.top + (int) this.pagesListScrollAmount) / scale);
 
             tessellator.draw();
-        }
-        else
-        {
-            drawRect(0, 0, width, top, 0x5F000000);
-            drawRect(0, bottom, width, height, 0x5F000000);
-            drawRect(pagesListWidth, top, pagesListWidth + SEPARATOR_WIDTH, bottom, 0x5F000000);
+        } else {
+            drawRect(0, 0, this.width, this.top, 0x5F000000);
+            drawRect(0, this.bottom, this.width, this.height, 0x5F000000);
+            drawRect(this.pagesListWidth, this.top, this.pagesListWidth + SEPARATOR_WIDTH, this.bottom, 0x5F000000);
         }
     }
 
-    private void overlayBackground(int minX, int maxX, int minY, int maxY)
-    {
-        if (mc.currentWorld == null)
-        {
-            Tessellator tessellator = Tessellator.instance;
-            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+    private void overlayBackground(int minX, int maxX, int minY, int maxY) {
+        if (this.mc.currentWorld == null) {
+            TessellatorGeneral tessellator = GLRenderer.getTessellator();
+            this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            GLRenderer.setColor4f(1f, 1f, 1f, 1f);
             float scale = 32F;
             tessellator.startDrawingQuads();
-            tessellator.setColorOpaque_I(0x404040);
+            tessellator.setColorOpaque1i(0x404040);
             tessellator.addVertexWithUV(minX, maxY, 0.0D, (float) minX / scale, (float) maxY / scale);
             tessellator.addVertexWithUV(maxX, maxY, 0.0D, (float) maxX / scale, (float) maxY / scale);
-            tessellator.setColorOpaque_I(0x404040);
+            tessellator.setColorOpaque1i(0x404040);
             tessellator.addVertexWithUV(maxX, minY, 0.0D, (float) maxX / scale, (float) minY / scale);
             tessellator.addVertexWithUV(minX, minY, 0.0D, (float) minX / scale, (float) minY / scale);
             tessellator.draw();
@@ -582,32 +563,32 @@ public class ScreenOptions
 
     @Override
     public void guiSpecificControllerInput(@NotNull ControllerInput controller) {
-        if(controller.buttonStart.pressedThisFrame()) {
-            this.keyPressed((char)0, Keyboard.KEY_ESCAPE, -1, -1);
+        if (controller.buttonStart.pressedThisFrame()) {
+            this.keyPressed((char) 0, Keyboard.KEY_ESCAPE, -1, -1);
         }
-        if(controller.buttonA.pressedThisFrame()) {
-            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 0);
+        if (controller.buttonA.pressedThisFrame()) {
+            this.mouseClicked((int) controller.cursorX, (int) controller.cursorY, 0);
         }
-        if(controller.buttonA.releasedThisFrame()) {
-            this.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 0);
+        if (controller.buttonA.releasedThisFrame()) {
+            this.mouseReleased((int) controller.cursorX, (int) controller.cursorY, 0);
         }
-        if(controller.buttonY.pressedThisFrame()) {
-            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 1);
+        if (controller.buttonY.pressedThisFrame()) {
+            this.mouseClicked((int) controller.cursorX, (int) controller.cursorY, 1);
         }
-        if(controller.buttonY.releasedThisFrame()) {
-            this.mouseReleased((int)controller.cursorX, (int)controller.cursorY, 1);
+        if (controller.buttonY.releasedThisFrame()) {
+            this.mouseReleased((int) controller.cursorX, (int) controller.cursorY, 1);
         }
-        if(controller.buttonX.pressedThisFrame()) {
-            this.mouseClicked((int)controller.cursorX, (int)controller.cursorY, 10);
+        if (controller.buttonX.pressedThisFrame()) {
+            this.mouseClicked((int) controller.cursorX, (int) controller.cursorY, 10);
         }
         if (controller.buttonB.pressedThisFrame()) {
-            mc.displayScreen(getParentScreen());
+            this.mc.displayScreen(getParentScreen());
         }
     }
 
     private void reloadIfReady() {
         if (queueReload) {
-            mc.renderGlobal.allChanged();
+            this.mc.renderGlobal.allChanged();
             queueReload = false;
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
index f76a3193c..9265f6782 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
@@ -6,12 +6,15 @@ import java.util.ArrayList;
 import java.util.List;
 
 import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.options.ScreenOptions;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.Global;
@@ -43,14 +46,14 @@ public class AvailableTexturePackListComponent
 
     @Override
     public void tick() {
-        if (size != mc.texturePackList.selectedPacks.size()){
-            size = mc.texturePackList.selectedPacks.size();
+        if (this.size != mc.texturePackList.selectedPacks.size()){
+            this.size = mc.texturePackList.selectedPacks.size();
             createTexturePackButtons();
             return;
         }
-    	updateTickCount++;
-    	if(updateTickCount >= 40) {
-    		updateTickCount = 0;
+        this.updateTickCount++;
+    	if(this.updateTickCount >= 40) {
+            this.updateTickCount = 0;
     		if(mc.texturePackList.updateAvailableTexturePacks()) {
     			createTexturePackButtons();
     		}
@@ -58,30 +61,30 @@ public class AvailableTexturePackListComponent
     }
     
     public void createTexturePackButtons() {
-        availablePacks.clear();
+        this.availablePacks.clear();
         
         List<TexturePack> texturePacks = mc.texturePackList.availableTexturePacks();
         for (int i = 0; i < texturePacks.size(); i++) {
             TexturePack texturePack = texturePacks.get(i);
             if (mc.texturePackList.selectedPacks.contains(texturePack)) continue;
             if (texturePack == mc.texturePackList.getDefaultTexturePack()) continue;
-            availablePacks.add(new TexturePackButton(i, texturePack));
+            this.availablePacks.add(new TexturePackButton(i, texturePack));
         }
     }
 
     @Override
     public int getHeight() {
-        if (availablePacks.isEmpty()) return 20;
-        return 3 + availablePacks.size() * (BUTTON_HEIGHT + 3);
+        if (this.availablePacks.isEmpty()) return 20;
+        return 3 + this.availablePacks.size() * (BUTTON_HEIGHT + 3);
     }
 
     @Override
-    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        if (availablePacks.isEmpty()) {
-            mc.font.renderCentered(Tessellator.instance, I18n.getInstance().translateKey("gui.options.page.asset_packs.label.no_packs"), x + width / 2, y + 4).setShadow().setColor(0x5F7F7F7F).call();
+    public void render(@NotNull ScreenOptions screenOptions, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        if (this.availablePacks.isEmpty()) {
+            mc.font.renderCentered(I18n.getInstance().translateKey("gui.options.page.asset_packs.label.no_packs"), x + width / 2, y + 4).setShadow().setColor(0x5F7F7F7F).call();
         }
-        for (int i = 0; i < availablePacks.size(); i++) {
-            TexturePackButton button = availablePacks.get(i);
+        for (int i = 0; i < this.availablePacks.size(); i++) {
+            TexturePackButton button = this.availablePacks.get(i);
             button.render(x, 3 + y + i * (BUTTON_HEIGHT + 3), width, relativeMouseX, relativeMouseY, i,
                     relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= 3 + i * (BUTTON_HEIGHT + 3) && relativeMouseY <= 3 + i * (BUTTON_HEIGHT + 3) + BUTTON_HEIGHT);
         }
@@ -89,8 +92,8 @@ public class AvailableTexturePackListComponent
 
     @Override
     public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        for (int i = 0; i < availablePacks.size(); i++) {
-            TexturePackButton button = availablePacks.get(i);
+        for (int i = 0; i < this.availablePacks.size(); i++) {
+            TexturePackButton button = this.availablePacks.get(i);
             if (button.isClickable() && relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= 3 + i * (BUTTON_HEIGHT + 3) && relativeMouseY <= 3 + i * (BUTTON_HEIGHT + 3) + BUTTON_HEIGHT) {
             	mc.texturePackList.setTexturePack(button.texturePack);
                 createTexturePackButtons();
@@ -115,7 +118,7 @@ public class AvailableTexturePackListComponent
     }
 
     private static class TexturePackButton {
-        private ButtonElement button;
+        private final ButtonElement button;
         public final int index;
         public final TexturePack texturePack;
         public final int height = BUTTON_HEIGHT;
@@ -123,7 +126,7 @@ public class AvailableTexturePackListComponent
         public TexturePackButton(int index, TexturePack texturePack) {
             this.index = index;
             this.texturePack = texturePack;
-            button = new ButtonElement(0, 0, 0, 20, 20, "+");
+            this.button = new ButtonElement(0, 0, 0, 20, 20, "+");
         }
 
         public boolean isClickable() {
@@ -131,79 +134,80 @@ public class AvailableTexturePackListComponent
         }
 
         public void render(int x, int y, int width, int mouseX, int mouseY, int index, boolean hovered) {
-            Tessellator tessellator = Tessellator.instance;
+            TessellatorGeneral tessellator = GLRenderer.getTessellator();
 
             setupButton(x, y, width, mouseX, mouseY);
 
             if (hovered) {
                 // Draw background
-                GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-                GL11.glDisable(GL11.GL_TEXTURE_2D);
+                GLRenderer.pushFrame();
+                GLRenderer.setShader(Shaders.COLOR);
+                GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
                 tessellator.startDrawingQuads();
 
-                tessellator.setColorOpaque_I(0x7F808080);
-                tessellator.addVertexWithUV(x - 2, y + height + 2, 0, 0, 1);
-                tessellator.addVertexWithUV(x + width + 2, y + height + 2, 0, 1, 1);
+                tessellator.setColorOpaque1i(0x7F808080);
+                tessellator.addVertexWithUV(x - 2, y + this.height + 2, 0, 0, 1);
+                tessellator.addVertexWithUV(x + width + 2, y + this.height + 2, 0, 1, 1);
                 tessellator.addVertexWithUV(x + width + 2, y - 2, 0, 1, 1);
                 tessellator.addVertexWithUV(x - 2, y - 2, 0, 0, 0);
 
-                tessellator.setColorOpaque_I(0);
-                tessellator.addVertexWithUV(x - 1, y + height + 1, 0, 0, 1);
-                tessellator.addVertexWithUV(x + width + 1, y + height + 1, 0, 1, 1);
+                tessellator.setColorOpaque1i(0);
+                tessellator.addVertexWithUV(x - 1, y + this.height + 1, 0, 0, 1);
+                tessellator.addVertexWithUV(x + width + 1, y + this.height + 1, 0, 1, 1);
                 tessellator.addVertexWithUV(x + width + 1, y - 1, 0, 1, 1);
                 tessellator.addVertexWithUV(x - 1, y - 1, 0, 0, 0);
 
                 tessellator.draw();
-                GL11.glEnable(GL11.GL_TEXTURE_2D);
+                GLRenderer.popFrame();
             }
 
             // Draw texture pack info
-            texturePack.bindThumbnailTexture(mc);
-            GL11.glColor4f(1, 1, 1, 1);
+            this.texturePack.bindThumbnailTexture(mc);
+            GLRenderer.setColor4f(1, 1, 1, 1);
 
             tessellator.startDrawingQuads();
-            tessellator.setColorOpaque_I(0xFFFFFF);
-            tessellator.addVertexWithUV(x, y + height, 0, 0, 1);
-            tessellator.addVertexWithUV(x + height, y + height, 0, 1, 1);
-            tessellator.addVertexWithUV(x + height, y, 0, 1, 0);
+            tessellator.setColorOpaque1i(0xFFFFFF);
+            tessellator.addVertexWithUV(x, y + this.height, 0, 0, 1);
+            tessellator.addVertexWithUV(x + this.height, y + this.height, 0, 1, 1);
+            tessellator.addVertexWithUV(x + this.height, y, 0, 1, 0);
             tessellator.addVertexWithUV(x, y, 0, 0, 0);
             tessellator.draw();
 
             int rgbVersion = 0x808080;
-            int format = texturePack.manifest.getFormat();
+            int format = this.texturePack.manifest.getFormat();
 
 			if(format == Global.ASSET_PACK_FORMAT) {
 				// Correct version
-                mc.font.render(Tessellator.instance, this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
-                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call();
-                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call();
+                mc.font.render(this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
+                mc.font.render(this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call();
+                mc.font.render(this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call();
 			}else if(format == -1) {
 				// Manifest error
-                mc.font.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
-                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call();
-                mc.font.render(Tessellator.instance, this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call();
+                mc.font.render(TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
+                mc.font.render(this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call();
+                mc.font.render(this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call();
 				rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
 			}else {
 				// Wrong texture pack version
 				I18n i18n = I18n.getInstance();
-                mc.font.render(Tessellator.instance, TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
-                mc.font.render(Tessellator.instance, i18n.translateKey("gui.options.page.asset_packs.label.outdated_pack.1"), x + this.height + 2, y + 12).setColor(0x808080).call();
-                mc.font.render(Tessellator.instance, i18n.translateKey("gui.options.page.asset_packs.label.outdated_pack.2"), x + this.height + 2, y + 22).setColor(0x808080).call();
+                mc.font.render(TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
+                mc.font.render(i18n.translateKey("gui.options.page.asset_packs.label.outdated_pack.1"), x + this.height + 2, y + 12).setColor(0x808080).call();
+                mc.font.render(i18n.translateKey("gui.options.page.asset_packs.label.outdated_pack.2"), x + this.height + 2, y + 22).setColor(0x808080).call();
 				rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
 			}
 
             if (hovered){
-                button.drawButton(mc, mouseX + x, mouseY + y - 3 - index * (BUTTON_HEIGHT + 3));
-                x -= button.width + 3;
+                this.button.drawButton(mc, mouseX + x, mouseY + y - 3 - index * (BUTTON_HEIGHT + 3));
+                x -= this.button.width + 3;
             }
 
-            String version = texturePack.manifest.getPackVersion();
+            String version = this.texturePack.manifest.getPackVersion();
             int versionWidth = mc.font.stringWidth(version);
-            mc.font.render(Tessellator.instance, texturePack.manifest.getPackVersion(), x + width - versionWidth - 2, y + 1).setColor(rgbVersion).call();
+            mc.font.render(this.texturePack.manifest.getPackVersion(), x + width - versionWidth - 2, y + 1).setColor(rgbVersion).call();
         }
         public void setupButton(int x, int y, int width, int mouseX, int mouseY){
-            button.setX(x + width - button.width - 1);
-            button.setY(y + (height - button.height)/2);
+            this.button.setX(x + width - this.button.width - 1);
+            this.button.setY(y + (this.height - this.button.height)/2);
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
index fd1831b52..73c0e958e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
@@ -2,15 +2,17 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.gui.options.ScreenOptions;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
-
-import static org.lwjgl.opengl.GL11.*;
 
 public abstract class ButtonComponent
     implements OptionsComponent
@@ -54,26 +56,22 @@ public abstract class ButtonComponent
     }
 
     @Override
-    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
+    public void render(@NotNull ScreenOptions screenOptions, int x, int y, int width, int relativeMouseX, int relativeMouseY)
     {
-        String translated = I18n.getInstance().translateKey(translationKey);
+        String translated = I18n.getInstance().translateKey(this.translationKey);
         int textColor = 0xFFFFFFFF;
         if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
             textColor = 0xFFFFFFA0;
         }
 
-        if (relativeMouseX >= 0 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
-            this.hovered = true;
-        } else {
-            this.hovered = false;
-        }
+        this.hovered = relativeMouseX >= 0 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING;
 
-        mc.font.render(Tessellator.instance, translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call();
-        resetButton.enabled = !isDefault();
+        mc.font.render(translated, x, y + (getHeight() / 2) - 4).setShadow().setColor(textColor).call();
+        this.resetButton.enabled = !isDefault();
         renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, 20, relativeMouseX, relativeMouseY);
         int stringWidth = mc.font.stringWidth(translated);
         int lineMaxX = x + width - BUTTON_WIDTH - 8;
-        if (resetButton.enabled) lineMaxX -= 20;
+        if (this.resetButton.enabled) lineMaxX -= 20;
         drawRect(x + stringWidth + 8, y + getHeight() / 2, lineMaxX, y + getHeight() / 2 + 1, 0x5F7F7F7F);
     }
 
@@ -83,7 +81,7 @@ public abstract class ButtonComponent
         if (relativeMouseX >= width - BUTTON_WIDTH && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
             mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
             buttonClicked(mouseButton, x, y, width, getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
-        } else if (resetButton.enabled && relativeMouseX >= width - BUTTON_WIDTH - 20 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
+        } else if (this.resetButton.enabled && relativeMouseX >= width - BUTTON_WIDTH - 20 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
             mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
             resetValue();
         }
@@ -111,15 +109,15 @@ public abstract class ButtonComponent
     @Override
     public boolean matchesSearchTerm(String term)
     {
-        return I18n.getInstance().translateKey(translationKey).toLowerCase().contains(term.toLowerCase());
+        return I18n.getInstance().translateKey(this.translationKey).toLowerCase().contains(term.toLowerCase());
     }
 
     protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY) {
-        if (resetButton.enabled) {
-            resetButton.xPosition = x + relativeButtonX - 20;
-            resetButton.yPosition = y + relativeButtonY;
+        if (this.resetButton.enabled) {
+            this.resetButton.xPosition = x + relativeButtonX - 20;
+            this.resetButton.yPosition = y + relativeButtonY;
 
-            resetButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+            this.resetButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
 
             if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
                 mc.currentScreen.setDesiredCursor(CursorShape.HAND);
@@ -127,21 +125,20 @@ public abstract class ButtonComponent
         }
     }
 
-    protected void drawRect(int minX, int minY, int maxX, int maxY, int argb)
-    {
-        Tessellator tessellator = Tessellator.instance;
-        GL11.glEnable(GL_BLEND);
-        GL11.glDisable(GL_TEXTURE_2D);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+    protected void drawRect(int minX, int minY, int maxX, int maxY, int argb) {
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_I(argb & 0x00FFFFFF, argb >> 24 & 0xff);
+        tessellator.setColor2i(argb & 0x00FFFFFF, argb >> 24 & 0xff);
         tessellator.addVertex(minX, maxY, 0.0D);
         tessellator.addVertex(maxX, maxY, 0.0D);
         tessellator.addVertex(maxX, minY, 0.0D);
         tessellator.addVertex(minX, minY, 0.0D);
         tessellator.draw();
-        GL11.glEnable(GL_TEXTURE_2D);
-        GL11.glDisable(GL_BLEND);
+        GLRenderer.popFrame();
     }
 
 }
